"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.stringify = void 0;
var stringify = function (value, spacing) {
    if (spacing === void 0) { spacing = ' '; }
    switch (value) {
        case null:
            return '!n';
        case undefined:
            return '!u';
        case true:
            return '!t';
        case false:
            return '!f';
    }
    if (Array.isArray(value))
        return "[".concat(spacing).concat(value.map(function (v) { return (0, exports.stringify)(v, spacing); }).join(',' + spacing)).concat(spacing, "]");
    if (value instanceof Uint8Array)
        return "".concat(value);
    switch (typeof value) {
        case 'number':
            return "".concat(value);
        case 'string':
            return JSON.stringify(value);
        case 'object': {
            var keys = Object.keys(value);
            return "{".concat(spacing).concat(keys
                .map(function (k) { return "".concat(k).concat(spacing, "=").concat(spacing).concat((0, exports.stringify)(value[k], spacing)); })
                .join(',' + spacing)).concat(spacing, "}");
        }
    }
    return '?';
};
exports.stringify = stringify;
