"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RpcCodec = void 0;
var RpcCodec = (function () {
    function RpcCodec(valueCodec, messageCodec) {
        this.valueCodec = valueCodec;
        this.messageCodec = messageCodec;
    }
    RpcCodec.prototype.encode = function (messages) {
        var valueCodec = this.valueCodec;
        var encoder = valueCodec.encoder;
        var writer = encoder.writer;
        writer.reset();
        this.messageCodec.encodeBatch(valueCodec, messages);
        return writer.flush();
    };
    RpcCodec.prototype.decode = function (data) {
        var valueCodec = this.valueCodec;
        var decoder = valueCodec.decoder;
        var reader = decoder.reader;
        reader.reset(data);
        return this.messageCodec.decodeBatch(valueCodec, data);
    };
    return RpcCodec;
}());
exports.RpcCodec = RpcCodec;
