"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.listToUint8 = exports.concatList = exports.concat = void 0;
var concat = function (a, b) {
    var res = new Uint8Array(a.length + b.length);
    res.set(a);
    res.set(b, a.length);
    return res;
};
exports.concat = concat;
var concatList = function (list) {
    var length = list.length;
    var size = 0, offset = 0;
    for (var i = 0; i < length; i++)
        size += list[i].length;
    var res = new Uint8Array(size);
    for (var i = 0; i < length; i++) {
        var item = list[i];
        res.set(item, offset);
        offset += item.length;
    }
    return res;
};
exports.concatList = concatList;
var listToUint8 = function (list) {
    switch (list.length) {
        case 0:
            return new Uint8Array(0);
        case 1:
            return list[0];
        default:
            return (0, exports.concatList)(list);
    }
};
exports.listToUint8 = listToUint8;
