"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var decodeAscii_1 = require("../decodeAscii");
var v18_1 = tslib_1.__importDefault(require("./v18"));
var hasBuffer = typeof Buffer !== 'undefined';
var utf8Slice = hasBuffer ? Buffer.prototype.utf8Slice : null;
var from = hasBuffer ? Buffer.from : null;
var shortDecoder = function (buf, start, length) { var _a; return (_a = (0, decodeAscii_1.decodeAsciiMax15)(buf, start, length)) !== null && _a !== void 0 ? _a : (0, v18_1.default)(buf, start, length); };
var midDecoder = function (buf, start, length) { var _a; return (_a = (0, decodeAscii_1.decodeAscii)(buf, start, length)) !== null && _a !== void 0 ? _a : (0, v18_1.default)(buf, start, length); };
var longDecoder = utf8Slice
    ? function (buf, start, length) { return utf8Slice.call(buf, start, start + length); }
    : from
        ? function (buf, start, length) {
            return from(buf)
                .subarray(start, start + length)
                .toString('utf8');
        }
        : v18_1.default;
var decoder = function (buf, start, length) {
    if (length < 16)
        return shortDecoder(buf, start, length);
    if (length < 32)
        return midDecoder(buf, start, length);
    return longDecoder(buf, start, length);
};
exports.default = decoder;
