"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fromCharCode = String.fromCharCode;
exports.default = (function (buf, start, length) {
    var offset = start;
    var end = offset + length;
    var points = [];
    while (offset < end) {
        var code = buf[offset++];
        if ((code & 0x80) !== 0) {
            var octet2 = buf[offset++] & 0x3f;
            if ((code & 0xe0) === 0xc0) {
                code = ((code & 0x1f) << 6) | octet2;
            }
            else {
                var octet3 = buf[offset++] & 0x3f;
                if ((code & 0xf0) === 0xe0) {
                    code = ((code & 0x1f) << 12) | (octet2 << 6) | octet3;
                }
                else {
                    if ((code & 0xf8) === 0xf0) {
                        var octet4 = buf[offset++] & 0x3f;
                        var unit = ((code & 0x07) << 0x12) | (octet2 << 0x0c) | (octet3 << 0x06) | octet4;
                        if (unit > 0xffff) {
                            unit -= 0x10000;
                            var unit0 = ((unit >>> 10) & 0x3ff) | 0xd800;
                            code = 0xdc00 | (unit & 0x3ff);
                            points.push(unit0);
                        }
                        else {
                            code = unit;
                        }
                    }
                }
            }
        }
        points.push(code);
    }
    return fromCharCode.apply(String, points);
});
