"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.printTree = void 0;
var printTree = function (tab, children) {
    if (tab === void 0) { tab = ''; }
    children = children.filter(Boolean);
    var str = '';
    for (var i = 0; i < children.length; i++) {
        var isLast = i >= children.length - 1;
        var fn = children[i];
        if (!fn)
            continue;
        var child = fn(tab + "".concat(isLast ? ' ' : '│', "  "));
        var branch = child ? (isLast ? '└─' : '├─') : '│ ';
        str += "\n".concat(tab).concat(branch, " ").concat(child);
    }
    return str;
};
exports.printTree = printTree;
