"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RadixTree = void 0;
var tslib_1 = require("tslib");
var TrieNode_1 = require("../trie/TrieNode");
var radix_1 = require("./radix");
var RadixTree = (function (_super) {
    tslib_1.__extends(RadixTree, _super);
    function RadixTree() {
        var _this = _super.call(this, '', undefined) || this;
        _this.size = 0;
        return _this;
    }
    RadixTree.prototype.set = function (key, value) {
        this.size += (0, radix_1.insert)(this, key, value);
    };
    RadixTree.prototype.get = function (key) {
        var node = (0, radix_1.find)(this, key);
        return node && node.v;
    };
    RadixTree.prototype.delete = function (key) {
        var removed = (0, radix_1.remove)(this, key);
        if (removed)
            this.size--;
        return removed;
    };
    return RadixTree;
}(TrieNode_1.TrieNode));
exports.RadixTree = RadixTree;
